"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var store_1 = require("../store");
var errors_1 = require("../helpers/errors");
var getWallet_1 = __importDefault(require("./getWallet"));
var constants_1 = require("../constants");
var transfer_1 = __importDefault(require("./transfer"));
var utils_1 = require("../helpers/utils");
var operator_1 = require("../services/operator");
var syncWallet_1 = require("../wallet/syncWallet");
var swaps_1 = require("../services/swaps");
function addOrder(config) {
    return __awaiter(this, void 0, void 0, function () {
        var nonce, totalPrice, _a, creditAmount, debitAmount, _b, creditToken, debitToken, _c, creditWallet, debitWallet, fundAmount, creditWalletBalance, _d, creditActiveStateSignatures, creditBalanceSignatures, debitActiveStateSignatures, debitBalanceSignatures, fulfillmentActiveStateSignatures, swapPayload_1, e_1, _e, creditWallet, debitWallet;
        return __generator(this, function (_f) {
            switch (_f.label) {
                case 0:
                    if (!store_1.store.swapWallets.has(config.address)) {
                        return [2, Promise.reject(new errors_1.NCError(errors_1.NCErrorCode.NO_TRADING_SETUP, 'Please make sure setupTrading() is called before adding orders'))];
                    }
                    nonce = utils_1.generateRandomNonce();
                    totalPrice = config.amount.multipliedBy(config.price);
                    _a = config.orderType === 'BUY'
                        ? { creditAmount: config.amount, debitAmount: totalPrice }
                        : { creditAmount: totalPrice, debitAmount: config.amount }, creditAmount = _a.creditAmount, debitAmount = _a.debitAmount;
                    creditAmount = creditAmount.shiftedBy(18);
                    debitAmount = debitAmount.shiftedBy(18);
                    _b = config.orderType === 'BUY'
                        ? { creditToken: config.baseTokenAddress, debitToken: config.quoteTokenAddress }
                        : { creditToken: config.quoteTokenAddress, debitToken: config.baseTokenAddress }, creditToken = _b.creditToken, debitToken = _b.debitToken;
                    _f.label = 1;
                case 1:
                    _f.trys.push([1, 14, , 21]);
                    return [4, getAvailableSwapWallets(config.address, creditToken, debitToken)];
                case 2:
                    _c = _f.sent(), creditWallet = _c.creditWallet, debitWallet = _c.debitWallet;
                    return [4, creditWallet.currentEon.finalizeAndHarvest()];
                case 3:
                    _f.sent();
                    fundAmount = debitAmount.minus(debitWallet.currentEon.balance);
                    if (!fundAmount.gt(constants_1.BN_ZERO)) return [3, 5];
                    return [4, transfer_1.default({
                            amount: fundAmount,
                            from: config.address,
                            to: debitWallet.address,
                            token: debitToken,
                        })];
                case 4:
                    _f.sent();
                    return [3, 7];
                case 5:
                    if (!fundAmount.lt(constants_1.BN_ZERO)) return [3, 7];
                    return [4, transfer_1.default({
                            amount: fundAmount.abs(),
                            from: debitWallet.address,
                            to: config.address,
                            token: debitToken,
                        })];
                case 6:
                    _f.sent();
                    _f.label = 7;
                case 7:
                    creditWalletBalance = creditWallet.currentEon.balance;
                    if (!creditWalletBalance.gt(constants_1.BN_ZERO)) return [3, 9];
                    return [4, transfer_1.default({
                            amount: creditWalletBalance,
                            from: creditWallet.address,
                            to: config.address,
                            token: creditToken,
                        })];
                case 8:
                    _f.sent();
                    _f.label = 9;
                case 9: return [4, swaps_1.createSwapOrderSignatures({
                        creditWallet: creditWallet,
                        debitWallet: debitWallet,
                        creditAmount: creditAmount,
                        debitAmount: debitAmount,
                        nonce: nonce,
                    })];
                case 10:
                    _d = _f.sent(), creditActiveStateSignatures = _d.creditActiveStateSignatures, creditBalanceSignatures = _d.creditBalanceSignatures, debitActiveStateSignatures = _d.debitActiveStateSignatures, debitBalanceSignatures = _d.debitBalanceSignatures, fulfillmentActiveStateSignatures = _d.fulfillmentActiveStateSignatures;
                    return [4, operator_1.operator.sendSwapOrder({
                            amount: debitAmount,
                            amountSwapped: creditAmount,
                            creditActiveStateSignatures: creditActiveStateSignatures,
                            debitActiveStateSignatures: debitActiveStateSignatures,
                            creditBalanceSignatures: creditBalanceSignatures,
                            debitBalanceSignatures: debitBalanceSignatures,
                            fulfillmentActiveStateSignatures: fulfillmentActiveStateSignatures,
                            creditWallet: creditWallet,
                            debitWallet: debitWallet,
                            eon: debitWallet.currentEon.eon,
                            nonce: nonce,
                        })];
                case 11:
                    swapPayload_1 = _f.sent();
                    return [4, syncWallet_1.syncWallet(creditWallet, syncWallet_1.SyncWalletEvent.SYNC_TRANSACTIONS, { payloads: [swapPayload_1] })];
                case 12:
                    _f.sent();
                    return [4, syncWallet_1.syncWallet(debitWallet, syncWallet_1.SyncWalletEvent.SYNC_TRANSACTIONS, { payloads: [swapPayload_1] })];
                case 13:
                    _f.sent();
                    return [2, creditWallet.currentEon.transactions.find(function (t) { return t.id === swapPayload_1.id; })];
                case 14:
                    e_1 = _f.sent();
                    if (!(e_1.message === errors_1.NCServerErrorCode.EON_NUMBER_OUT_OF_SYNC)) return [3, 19];
                    return [4, utils_1.sleep(2000)];
                case 15:
                    _f.sent();
                    return [4, getAvailableSwapWallets(config.address, creditToken, debitToken)];
                case 16:
                    _e = _f.sent(), creditWallet = _e.creditWallet, debitWallet = _e.debitWallet;
                    return [4, syncWallet_1.syncWallet(creditWallet, syncWallet_1.SyncWalletEvent.FULL_SYNC)];
                case 17:
                    _f.sent();
                    return [4, syncWallet_1.syncWallet(debitWallet, syncWallet_1.SyncWalletEvent.FULL_SYNC)];
                case 18:
                    _f.sent();
                    return [2, addOrder(config)];
                case 19: return [2, Promise.reject(e_1)];
                case 20: return [3, 21];
                case 21: return [2];
            }
        });
    });
}
exports.default = addOrder;
function getAvailableSwapWallets(address, creditToken, debitToken) {
    return __awaiter(this, void 0, void 0, function () {
        var swapWalletAddresses, i, creditWallet, debitWallet, e_2;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 6, , 7]);
                    swapWalletAddresses = store_1.store.swapWallets.get(address);
                    i = 0;
                    _a.label = 1;
                case 1:
                    if (!(i < swapWalletAddresses.length)) return [3, 5];
                    return [4, getWallet_1.default(swapWalletAddresses[i], creditToken, address)];
                case 2:
                    creditWallet = _a.sent();
                    return [4, getWallet_1.default(swapWalletAddresses[i], debitToken, address)];
                case 3:
                    debitWallet = _a.sent();
                    if (creditWallet.currentEon.isAvailableForSwaps &&
                        debitWallet.currentEon.isAvailableForSwaps) {
                        return [2, { creditWallet: creditWallet, debitWallet: debitWallet }];
                    }
                    _a.label = 4;
                case 4:
                    i++;
                    return [3, 1];
                case 5: return [2, Promise.reject(new errors_1.NCError(errors_1.NCErrorCode.SWAP_LIMIT_REACHED_ERROR))];
                case 6:
                    e_2 = _a.sent();
                    return [2, Promise.reject(e_2)];
                case 7: return [2];
            }
        });
    });
}
//# sourceMappingURL=addOrder.js.map