"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var init_1 = __importDefault(require("./init"));
var buySLA_1 = __importDefault(require("./buySLA"));
var deposit_1 = __importDefault(require("./deposit"));
var getBalance_1 = __importDefault(require("./getBalance"));
var getEon_1 = __importDefault(require("./getEon"));
var getEra_1 = __importDefault(require("./getEra"));
var getParentChainBalance_1 = __importDefault(require("./getParentChainBalance"));
var getOrderBook_1 = __importDefault(require("./getOrderBook"));
var approveDeposits_1 = __importDefault(require("./approveDeposits"));
var getSLAInfo_1 = __importDefault(require("./getSLAInfo"));
var shutdown_1 = __importDefault(require("./shutdown"));
var getSLAStatus_1 = __importDefault(require("./getSLAStatus"));
var withdraw_1 = __importDefault(require("./withdraw"));
var registerWallet_1 = __importDefault(require("./registerWallet"));
var registerBulkWallets_1 = __importDefault(require("./registerBulkWallets"));
var transfer_1 = __importDefault(require("./transfer"));
var addOrder_1 = __importDefault(require("./addOrder"));
var cancelOrder_1 = __importDefault(require("./cancelOrder"));
var getSupportedTokens_1 = __importDefault(require("./getSupportedTokens"));
var isWalletRegistered_1 = __importDefault(require("./isWalletRegistered"));
var confirmWithdrawal_1 = __importDefault(require("./confirmWithdrawal"));
var getTransfer_1 = __importDefault(require("./getTransfer"));
var getTransfers_1 = __importDefault(require("./getTransfers"));
var setupTrading_1 = __importDefault(require("./setupTrading"));
var getWithdrawalLimit_1 = __importDefault(require("./getWithdrawalLimit"));
var getWallet_1 = __importDefault(require("./getWallet"));
var getWithdrawalFee_1 = __importDefault(require("./getWithdrawalFee"));
var getLastSubmittedEon_1 = __importDefault(require("./getLastSubmittedEon"));
var isWalletRecovered_1 = __importDefault(require("./isWalletRecovered"));
var subscribe_1 = __importDefault(require("./subscribe"));
var issueDeliveryChallenge_1 = __importDefault(require("./issueDeliveryChallenge"));
var issueStateUpdateChallenge_1 = __importDefault(require("./issueStateUpdateChallenge"));
var recoverFunds_1 = __importDefault(require("./recoverFunds"));
var isRecoveryMode_1 = __importDefault(require("./isRecoveryMode"));
var hasOutstandingChallenges_1 = __importDefault(require("./hasOutstandingChallenges"));
var addPrivateKey_1 = __importDefault(require("./addPrivateKey"));
var getBlocksToWithdrawalConfirmation_1 = __importDefault(require("./getBlocksToWithdrawalConfirmation"));
var transferParentChain_1 = __importDefault(require("./transferParentChain"));
var signToS_1 = require("./signToS");
var store_1 = require("../store");
var getMyOrders_1 = __importDefault(require("./getMyOrders"));
exports.nocust = {
    addPrivateKey: addPrivateKey_1.default,
    approveDeposits: approveDeposits_1.default,
    buySLA: buySLA_1.default,
    confirmWithdrawal: confirmWithdrawal_1.default,
    deposit: deposit_1.default,
    getBalance: getBalance_1.default,
    getBlocksPerEon: function () { return store_1.store.blocksPerEon; },
    getBlocksToWithdrawalConfirmation: getBlocksToWithdrawalConfirmation_1.default,
    getEon: getEon_1.default,
    getEra: getEra_1.default,
    getParentChainBalance: getParentChainBalance_1.default,
    getOrderBook: getOrderBook_1.default,
    getSLAInfo: getSLAInfo_1.default,
    getSLAStatus: getSLAStatus_1.default,
    getSupportedTokens: getSupportedTokens_1.default,
    getTransfer: getTransfer_1.default,
    getTransfers: getTransfers_1.default,
    getWallet: getWallet_1.default,
    getWithdrawalFee: getWithdrawalFee_1.default,
    getWithdrawalLimit: getWithdrawalLimit_1.default,
    getLastSubmittedEon: getLastSubmittedEon_1.default,
    hasOutstandingChallenges: hasOutstandingChallenges_1.default,
    init: init_1.default,
    isWalletRegistered: isWalletRegistered_1.default,
    isRecoveryMode: isRecoveryMode_1.default,
    issueDeliveryChallenge: issueDeliveryChallenge_1.default,
    issueStateUpdateChallenge: issueStateUpdateChallenge_1.default,
    registerWallet: registerWallet_1.default,
    registerBulkWallets: registerBulkWallets_1.default,
    recoverFunds: recoverFunds_1.default,
    shutdown: shutdown_1.default,
    subscribe: subscribe_1.default,
    addOrder: addOrder_1.default,
    cancelOrder: cancelOrder_1.default,
    getMyOrders: getMyOrders_1.default,
    transfer: transfer_1.default,
    transferParentChain: transferParentChain_1.default,
    withdraw: withdraw_1.default,
    signToS: signToS_1.signToS,
    setupTrading: setupTrading_1.default,
    isWalletRecovered: isWalletRecovered_1.default,
};
//# sourceMappingURL=index.js.map