"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var store_1 = require("../store");
var websocket_1 = require("../services/websocket");
var NCEventType;
(function (NCEventType) {
    NCEventType["TRANSFER_CONFIRMATION"] = "TRANSFER_CONFIRMATION";
})(NCEventType = exports.NCEventType || (exports.NCEventType = {}));
function subscribe(config) {
    var address = config.address, token = config.token, event = config.event, callback = config.callback;
    if (token == null)
        token = store_1.store.contractAddress;
    if (event === NCEventType.TRANSFER_CONFIRMATION) {
        return websocket_1.websocket.events.on(websocket_1.websocket.defineEvent(websocket_1.WSEventType.TRANSFER_CONFIRMATION, address, token), function (payload) {
            if (payload.recipient.address === address && payload.recipient.token === token) {
                callback(payload);
            }
        });
    }
    else {
        throw new Error('Invalid event type, please use one of NCEventType');
    }
}
exports.default = subscribe;
//# sourceMappingURL=subscribe.js.map