"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var blockchain_1 = require("../services/blockchain");
var store_1 = require("../store");
var errors_1 = require("../helpers/errors");
function transferParentChain(config) {
    return __awaiter(this, void 0, void 0, function () {
        var from, to, token, amount, gasPrice, tx, tx, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    from = config.from, to = config.to, token = config.token, amount = config.amount, gasPrice = config.gasPrice;
                    if (!blockchain_1.blockchain.isPrivateKeyAdded(from)) {
                        return [2, Promise.reject(new errors_1.NCError(errors_1.NCErrorCode.NO_PRIVATE_KEY))];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 6, , 7]);
                    if (!(token === store_1.store.contractAddress || token == null)) return [3, 3];
                    return [4, blockchain_1.blockchain.sendEther({ from: from, to: to, amount: amount, gasPrice: gasPrice })];
                case 2:
                    tx = _a.sent();
                    return [2, tx.transactionHash];
                case 3: return [4, blockchain_1.blockchain.sendERC20({ from: from, to: to, token: token, amount: amount, gasPrice: gasPrice })];
                case 4:
                    tx = _a.sent();
                    return [2, tx.transactionHash];
                case 5: return [3, 7];
                case 6:
                    e_1 = _a.sent();
                    return [2, Promise.reject(e_1)];
                case 7: return [2];
            }
        });
    });
}
exports.default = transferParentChain;
//# sourceMappingURL=transferParentChain.js.map