"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = __importDefault(require("axios"));
var store_1 = require("../../store");
var errors_1 = require("../../helpers/errors");
function request(url, method, data, params) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var response, e_1;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    _d.trys.push([0, 2, , 3]);
                    return [4, axios_1.default({
                            method: method,
                            url: store_1.store.operatorUrl + url,
                            data: data,
                            params: params,
                        })];
                case 1:
                    response = _d.sent();
                    if (typeof response.data === 'string') {
                        throw new Error('Invalid JSON of server response');
                    }
                    return [2, response.data];
                case 2:
                    e_1 = _d.sent();
                    if (((_a = e_1.response) === null || _a === void 0 ? void 0 : _a.status) === 404) {
                        return [2, Promise.reject(new errors_1.NCServerError(errors_1.NCServerErrorCode.NOT_FOUND))];
                    }
                    else if (((_b = e_1.response) === null || _b === void 0 ? void 0 : _b.status) >= 500) {
                        return [2, Promise.reject(new errors_1.NCServerError(errors_1.NCServerErrorCode.INTERNAL_ERROR))];
                    }
                    else if (((_c = e_1.response) === null || _c === void 0 ? void 0 : _c.status) === 400) {
                        if (Array.isArray(e_1.response.data)) {
                            return [2, Promise.reject(new errors_1.NCServerError(e_1.response.data[0].code, e_1.response.data[0].message))];
                        }
                        else if (e_1.response.data.non_field_errors) {
                            return [2, Promise.reject(new errors_1.NCServerError(e_1.response.data.non_field_errors[0].code, e_1.response.data.non_field_errors[0].message))];
                        }
                        else {
                            console.log('Error:', e_1.response.data);
                            return [2, Promise.reject(new errors_1.NCServerError(errors_1.NCServerErrorCode.UNKNOWN_ERROR, '', { e: e_1.response }))];
                        }
                    }
                    else {
                        return [2, Promise.reject(new errors_1.NCServerError(errors_1.NCServerErrorCode.UNKNOWN_ERROR, '', { e: e_1.response }))];
                    }
                    return [3, 3];
                case 3: return [2];
            }
        });
    });
}
exports.request = request;
//# sourceMappingURL=request.js.map