import { Wallet } from '../wallet';
export interface StorageEngine {
    get(key: string): Promise<string>;
    set(key: string, value: string): Promise<boolean>;
    delete(key: string): Promise<boolean>;
    [T: string]: any;
}
declare function init(engine: StorageEngine): void;
declare function retrieveWallet(address: string, token: string): Promise<Wallet | null>;
declare function queueWalletStorage(wallet: Wallet): void;
declare function storeQueuedWallets(): Promise<void>;
export declare const storage: {
    init: typeof init;
    queueWalletStorage: typeof queueWalletStorage;
    retrieveWallet: typeof retrieveWallet;
    storeQueuedWallets: typeof storeQueuedWallets;
};
export {};
