"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var json_bigint_1 = __importDefault(require("json-bigint"));
var store_1 = require("../store");
var parseWallet_1 = require("../wallet/parseWallet");
var utils_1 = require("../helpers/utils");
var wallet_1 = require("../wallet");
var storageEngine;
function init(engine) {
    storageEngine = engine;
}
function retrieveWallet(address, token) {
    return __awaiter(this, void 0, void 0, function () {
        var keyConfig, walletData, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    keyConfig = { address: address, token: token, contract: store_1.store.contractAddress, network: store_1.store.networkId };
                    return [4, storageEngine.get(defineKey(keyConfig))];
                case 1:
                    walletData = _a.sent();
                    return [2, walletData ? parseWallet_1.parseWallet(walletData) : null];
                case 2:
                    e_1 = _a.sent();
                    console.log(e_1);
                    return [2, null];
                case 3: return [2];
            }
        });
    });
}
var queue = new Set();
function queueWalletStorage(wallet) {
    queue.add(utils_1.defineWalletKey(wallet.address, wallet.token));
}
function storeQueuedWallets() {
    return __awaiter(this, void 0, void 0, function () {
        var queue_1, queue_1_1, key, _a, token, address, wallet, keyConfig, e_2, e_3_1;
        var e_3, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _c.trys.push([0, 7, 8, 9]);
                    queue_1 = __values(queue), queue_1_1 = queue_1.next();
                    _c.label = 1;
                case 1:
                    if (!!queue_1_1.done) return [3, 6];
                    key = queue_1_1.value;
                    _c.label = 2;
                case 2:
                    _c.trys.push([2, 4, , 5]);
                    _a = __read(key.split('/'), 2), token = _a[0], address = _a[1];
                    wallet = wallet_1.getWallet(address, token);
                    keyConfig = {
                        address: wallet.address,
                        token: wallet.token,
                        contract: store_1.store.contractAddress,
                        network: store_1.store.networkId,
                    };
                    return [4, storageEngine.set(defineKey(keyConfig), json_bigint_1.default.stringify(wallet))];
                case 3:
                    _c.sent();
                    queue.delete(key);
                    return [3, 5];
                case 4:
                    e_2 = _c.sent();
                    console.log("[INTERNAL] Error storing wallet(" + key + ") to storage", e_2);
                    return [3, 5];
                case 5:
                    queue_1_1 = queue_1.next();
                    return [3, 1];
                case 6: return [3, 9];
                case 7:
                    e_3_1 = _c.sent();
                    e_3 = { error: e_3_1 };
                    return [3, 9];
                case 8:
                    try {
                        if (queue_1_1 && !queue_1_1.done && (_b = queue_1.return)) _b.call(queue_1);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7];
                case 9: return [2];
            }
        });
    });
}
var defineKey = function (config) {
    return config.contract + '/' + config.network + '/' + config.address + '/' + config.token;
};
exports.storage = {
    init: init,
    queueWalletStorage: queueWalletStorage,
    retrieveWallet: retrieveWallet,
    storeQueuedWallets: storeQueuedWallets,
};
//# sourceMappingURL=storage.js.map