import BigNumber from 'bignumber.js';
import { Wallet } from '../wallet';
import { Transaction } from '../wallet/transaction';
import { Signature } from '../wallet/signature';
declare type CreateSwapOrderSignaturesConfig = {
    creditWallet: Wallet;
    debitWallet: Wallet;
    creditAmount: BigNumber;
    debitAmount: BigNumber;
    nonce: BigNumber;
};
declare type OrderSignatures = {
    creditActiveStateSignatures: Signature[];
    debitActiveStateSignatures: Signature[];
    fulfillmentActiveStateSignatures: Signature[];
    creditBalanceSignatures: Signature[];
    debitBalanceSignatures: Signature[];
};
export declare function createSwapOrderSignatures(config: CreateSwapOrderSignaturesConfig): Promise<OrderSignatures>;
export declare function createCancellationSignatures(debitWallet: Wallet, creditWallet: Wallet, swap: Transaction): Promise<{
    debitCancellationSignatures: Array<Signature>;
    creditCancellationSignatures: Array<Signature>;
}>;
export declare function createFinalizationSignatures(creditWallet: Wallet, swap: Transaction): Promise<{
    finalizationSignatures: Array<Signature>;
}>;
export {};
