import BigNumber from 'bignumber.js';
import { SLAInfo } from './nocust/getSLAInfo';
import { Wallet } from './wallet';
declare class AppStore {
    contractAddress: string;
    rpcUrl: string;
    operatorUrl: string;
    networkId: number;
    tosHash: string;
    genesisBlock: number;
    blocksPerEon: number;
    slackPeriod: number;
    extendedSlackPeriod: number;
    eonsKept: number;
    depositsKept: number;
    contractOwner: string;
    minChallengeGasCost: BigNumber;
    wallets: Map<string, Wallet>;
    swapWallets: Map<string, string[]>;
    slaInfo: SLAInfo | undefined;
}
export declare let store: AppStore;
export declare const createStore: () => void;
export declare const getToSHash: () => Promise<string>;
export {};
