"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var web3_1 = __importDefault(require("web3"));
var store_1 = require("../store");
var constants_1 = require("../constants");
function hashActiveState(state, checkSpentAndGained) {
    if (checkSpentAndGained === void 0) { checkSpentAndGained = false; }
    var soliditySha3 = web3_1.default.utils.soliditySha3;
    if (checkSpentAndGained) {
        if (state.spent === constants_1.BN_ZERO && state.gained === constants_1.BN_ZERO) {
            return constants_1.EMPTY_HASH;
        }
    }
    return soliditySha3({ t: 'bytes32', v: soliditySha3({ t: 'address', v: store_1.store.contractAddress }) }, { t: 'bytes32', v: soliditySha3({ t: 'address', v: state.token }) }, { t: 'bytes32', v: soliditySha3({ t: 'address', v: state.address }) }, { t: 'uint64', v: state.trailIdentifier }, { t: 'uint256', v: state.eon }, { t: 'bytes32', v: state.transactionSetHash }, { t: 'uint256', v: state.spent.toFixed(0) }, { t: 'uint256', v: state.gained.toFixed(0) });
}
exports.hashActiveState = hashActiveState;
//# sourceMappingURL=activeState.js.map