export interface MerkleTree {
    hash: string;
    parent?: MerkleTree;
    leftChild?: MerkleTree;
    rightChild?: MerkleTree;
    height: number;
}
export interface MerkleProof {
    root: string;
    path: string[];
    trailIdentifier: number;
    leafChecksum: string;
}
export declare const constructMerkleTree: (leaves: MerkleTree[]) => MerkleTree;
export declare const EMPTY_MERKLE_TREE: MerkleTree;
