"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("../helpers/utils");
function createSignature(address, hash, signature) {
    signature = utils_1.remove0x(signature);
    var v = parseInt(signature.slice(128, 130), 16);
    if (v < 27)
        v += 27;
    return {
        address: address,
        hash: hash,
        r: signature.slice(0, 64),
        s: signature.slice(64, 128),
        v: v.toString(16),
    };
}
exports.createSignature = createSignature;
exports.signatureToRSV = function (_a) {
    var r = _a.r, s = _a.s, v = _a.v;
    return r + s + v;
};
//# sourceMappingURL=signature.js.map